package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserCoupon;
import com.izouma.awesomeadmin.service.UserCouponService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/userCoupon")
@RequiresAuthentication
public class UserCouponController {

    @Autowired
    private UserCouponService userCouponService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserCoupon record) {
        List<UserCoupon> pp = userCouponService.getUserCouponList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getUserCoupon", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserCoupon(@RequestParam(required = false, value = "id") String id) {
        UserCoupon data = userCouponService.getUserCouponById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserCoupon record) {
        UserCoupon data = userCouponService.getUserCoupon(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserCoupon record) {
        Map<String, Object> result = new HashMap<>();

        List<UserCoupon> pp =userCouponService.getUserCouponByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserCoupon record) {
        boolean num = userCouponService.createUserCoupon(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserCoupon(UserCoupon record) {
        boolean num = userCouponService.updateUserCoupon(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserCoupon(@RequestParam(required = true, value = "id") String id) {

        boolean num = userCouponService.deleteUserCoupon(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserCoupon record) throws Exception {

    List<UserCoupon> userCoupons = userCouponService.getUserCouponList(record);


        String sheetName = "user_coupon";
        String titleName = "用户优惠券数据表";
        String fileName = "用户优惠券表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "优惠券" ,   "用户" ,   "是否使用" ,   "到期时间"  };
        String[][] dataList = new String[userCoupons.size()][10];

        for (int i = 0; i < userCoupons.size(); i++) {

                        dataList[i][0] = String.valueOf(userCoupons.get(i).getId());
                        dataList[i][1] = String.valueOf(userCoupons.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(userCoupons.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(userCoupons.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(userCoupons.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(userCoupons.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(userCoupons.get(i).getCouponId());
                        dataList[i][7] = String.valueOf(userCoupons.get(i).getUserId());
                        dataList[i][8] = String.valueOf(userCoupons.get(i).getIsUsed());
                        dataList[i][9] = String.valueOf(userCoupons.get(i).getEndTime());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

